{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainUnit;

{ GrabScreen - (C) by Vladimir Kladov, 2002
  Freeware.

  http://bonanzas.rinet.ru
  mailto: bonanzas@online.sinor.ru
}

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,
  mckObjs, Controls, mckCtrls {$ENDIF};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

const AppVersion = '2.4a (C) by Vladimir Kladov, 2002-2003';
      WM_SelectForegroundWnd = WM_USER + 19;

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TForm1 = class; PForm1 = TForm1; {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    KOLApplet1: TKOLApplet;
    TrayIcon1: TKOLTrayIcon;
    PopupMenu1: TKOLPopupMenu;
    SaveAsDialog1: TKOLOpenSaveDialog;
    Timer1: TKOLTimer;
    Label1: TKOLLabel;
    Timer2: TKOLTimer;
    Timer3: TKOLTimer;
    procedure PopupMenu1miExitMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miRgnMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miWndMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miScrMenu(Sender: PMenu; Item: Integer);
    procedure KOLForm1Resize(Sender: PObj);
    procedure KOLForm1MouseDown(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure KOLForm1MouseMove(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure Timer1Timer(Sender: PObj);
    procedure KOLForm1MouseUp(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure PopupMenu1miRepeatMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miAutoMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miFolderMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miCursorMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miHotkeyMenu(Sender: PMenu; Item: Integer);
    function KOLForm1Message(var Msg: tagMSG; var Rslt: Integer): Boolean;
    procedure KOLForm1Destroy(Sender: PObj);
    procedure PopupMenu1miFrameMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miSvAsMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1miClipBrdMenu(Sender: PMenu; Item: Integer);
    procedure KOLForm1Close(Sender: PObj; var Accept: Boolean);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure Timer2Timer(Sender: PObj);
    procedure TrayIcon1Mouse(Sender: PObj; Message: Word);
    procedure Timer3Timer(Sender: PObj);
    function KOLApplet1Message(var Msg: tagMSG;
      var Rslt: Integer): Boolean;
  private
    { Private declarations }
    RegionStart: TPoint;
    SelectingRgn, SelectingRgn2: Boolean;
    SelectingWnd: Boolean;
    WndDist: Integer;
    BestWnd: HWnd;
    LastRgn: TRect;
    LastFilename: String;
    FHotkeyRegistered: array[ 0..4 ] of Boolean;
    Bmp: PBitmap;
    procedure DoSelections;
    procedure DoSelectingRgn;
    procedure DoSelectingRgn2;
    procedure DoSelectingWnd;
    procedure SelectNextWnd( Key: DWORD );
    procedure SelectWnd( W: HWnd );
    procedure StartCaptureRegion;
    procedure StartCaptureWnd;
    procedure StartCaptureScreen;
    procedure RepeatLastCapture;
    procedure CaptureRegion( const R: TRect );
    procedure DoGrab;
    procedure SaveFile( const Filename: String );
  public
    { Public declarations }
    HotKey, HotMod: array[ 0..4 ] of DWORD;
    function SetupHotkey( Func: Integer; Key: DWORD; M: DWORD; UseCurMod: Boolean=TRUE ): Boolean;
    procedure SaveSettings;
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  RunOnce, RunOnceWindow, RunOnceScreen: Boolean;

const
  RegKey = 'Software\Bonanzas\GrabScreen\';

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses JPegObj, KolPng, UnitSelectHotKey, Lnk;

var Attempts: Integer;
    LastMouseMoveP: TPoint;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainUnit_1.inc}
{$ENDIF}

{$R CursorsGrab.res}

{ TForm1 }

procedure TForm1.PopupMenu1miExitMenu(Sender: PMenu; Item: Integer);
begin
  SaveSettings;
  PostQuitMessage( 0 );
end;

procedure TForm1.PopupMenu1miRgnMenu(Sender: PMenu; Item: Integer);
begin
  TrayIcon1.Tooltip := 'Grab Region';
  StartCaptureRegion;
end;

procedure TForm1.PopupMenu1miWndMenu(Sender: PMenu; Item: Integer);
begin
  TrayIcon1.Tooltip := 'Grab Window';
  StartCaptureWnd;
end;

procedure TForm1.PopupMenu1miScrMenu(Sender: PMenu; Item: Integer);
begin
  TrayIcon1.Tooltip := 'Grab Screen';
  StartCaptureScreen;
end;

procedure TForm1.KOLForm1Resize(Sender: PObj);
var Rgn, Rgn1: HRgn;
    R: TRect;
    P: TPoint;
    V: Boolean;
begin
  if Form.Handle = 0 then Exit;
  if not Form.Visible then Exit;
  R := Form.ClientRect;
  V := (Form.ClientWidth > Label1.Width + Label1.Left * 2) and
       (Form.ClientHeight > Label1.Height + Label1.Top * 2);
  if Label1.Visible <> V then
    Label1.Visible := V;
  if SelectingRgn then
    Rgn := CreateRectRgn( 0, 0, 1, 1 )
    else
  if SelectingWnd then
  begin
    Label1.Caption := '';
    Rgn := CreateRectRgnIndirect( R );
    InflateRect( R, -4, -4 );
    Rgn1 := CreateRectRgnIndirect( R );
    CombineRgn( Rgn, Rgn, Rgn1, RGN_DIFF );
    DeleteObject( Rgn1 );
    GetCursorPos( P );
    P := Form.Screen2Client( P );
    R.TopLeft := P;
    Dec( R.Left );
    Dec( R.Right );
    R.Right := R.Left + 2;
    R.Bottom := R.Top + 2;
    Rgn1 := CreateRectRgnIndirect( R );
    CombineRgn( Rgn, Rgn, Rgn1, RGN_OR );
    DeleteObject( Rgn1 );
  end
    else
  if SelectingRgn2 or PopupMenu1.ItemChecked[ miFrame ] then
  begin
    Label1.Caption := Int2Str( R.Right - R.Left + 1 ) + 'x' +
                      Int2Str( R.Bottom - R.Top + 1 );
    Rgn := CreateRectRgnIndirect( R );
    InflateRect( R, -1, -1 );
    Rgn1 := CreateRectRgnIndirect( R );
    CombineRgn( Rgn, Rgn, Rgn1, RGN_DIFF );
    DeleteObject( Rgn1 );
    if SelectingRgn2 and Label1.Visible then
    begin
      R := Label1.BoundsRect;
      Dec( R.Right );
      Dec( R.Bottom );
      Rgn1 := CreateRectRgnIndirect( R );
      CombineRgn( Rgn, Rgn, Rgn1, RGN_OR );
      DeleteObject( Rgn1 );
    end;
  end
    else Exit;
  SetWindowRgn( Form.Handle, Rgn, TRUE );
end;

procedure TForm1.KOLForm1MouseDown(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  if Mouse.Button = mbLeft then
  begin
    if SelectingRgn then
    begin // start capture region
      GetCursorPos( RegionStart );
      Form.Left := RegionStart.x;
      Form.Top := RegionStart.y;
      SelectingRgn := FALSE;
      SelectingRgn2 := TRUE;
    end
      else
    if SelectingRgn2 or SelectingWnd then
    begin
      ReleaseCapture;
      Form.Hide;
      Timer1.Enabled := FALSE;
      SelectingRgn2 := FALSE;
      SelectingWnd := FALSE;
      Timer2.Enabled := TRUE;
    end;
  end;
end;

procedure TForm1.KOLForm1MouseMove(Sender: PControl;
  var Mouse: TMouseEventData);
var P: TPoint;
begin
  GetCursorPos( P );
  if not( (P.X = LastMouseMoveP.X) and (P.Y = LastMouseMoveP.Y) ) or
     not SelectingWnd then
    DoSelections;
  LastMouseMoveP := P;
end;

procedure TForm1.Timer1Timer(Sender: PObj);
var Mouse: TMouseEventData;
var P: TPoint;
begin
  GetCursorPos( P );
  Mouse.X := P.X;
  Mouse.Y := P.Y;
  KOLForm1MouseMove( nil, Mouse );
end;

procedure TForm1.DoSelectingRgn;
var P: TPoint;
begin
  GetCursorPos( P );
  Form.Left := P.x;
  Form.Top := P.y;
  SetCursor( Form.Cursor );
end;

procedure TForm1.DoSelectingRgn2;
var P: TPoint;
    R: TRect;
begin
  GetCursorPos( P );
  R.TopLeft := P;
  R.BottomRight := P;
  if R.Left > RegionStart.x then R.Left := RegionStart.x;
  if R.Right < RegionStart.x then R.Right := RegionStart.x;
  if R.Top > RegionStart.y then R.Top := RegionStart.y;
  if R.Bottom < RegionStart.y then R.Bottom := RegionStart.y;
  if R.Right >= RegionStart.x then Inc( R.Right );
  if R.Bottom >= RegionStart.y then Inc( R.Bottom );
  Form.BoundsRect := R;
end;

procedure TForm1.KOLForm1MouseUp(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  if Mouse.Button = mbRight then
  begin
    Form.Hide;
    Timer1.Enabled := FALSE;
    SelectingRgn := FALSE;
    SelectingRgn2 := FALSE;
    SelectingWnd := FALSE;
    ReleaseCapture;
    if RunOnce then
      PostQuitMessage( 0 );
  end;
end;

procedure TForm1.DoSelections;
begin
  if SelectingRgn then
    DoSelectingRgn
  else
  if SelectingRgn2 then
    DoSelectingRgn2
  else
  if SelectingWnd then
    DoSelectingWnd
  else
    Timer1.Enabled := FALSE;
end;

var CtrlPressed: Boolean;
function EnumWndProc( Wnd: HWnd; P: PPoint ): BOOL; stdcall;
var R: TRect;
    Dist: Integer;

    procedure CheckWndAndItsChildren( Wnd: HWnd );
    begin
      GetWindowRect( Wnd, R );
      if PtInRect( R, P^ ) then
      begin
        if CtrlPressed then
          Dist := SQR( (R.Left + R.Right) - 2 * P.x ) +
                  SQR( (R.Top + R.Bottom) - 2 * P.y )
        else
          Dist := SQR( (R.Left - P.X) ) + SQR( (R.Top - P.Y) );
        if (Form1.BestWnd = 0) or (Dist <= Form1.WndDist) then
        begin
          Form1.WndDist := Dist;
          Form1.BestWnd := Wnd;
        end;
      end;
      Wnd := GetWindow( Wnd, GW_CHILD );
      while Wnd <> 0 do
      begin
        CheckWndAndItsChildren( Wnd );
        Wnd := GetWindow( Wnd, GW_HWNDNEXT );
      end;
    end;
begin
  if Wnd <> Form1.Form.Handle then
  if Wnd <> Applet.Handle then
  if IsWindowVisible( Wnd ) then
  begin
    CheckWndAndItsChildren( Wnd );
  end;
  Result := TRUE;
end;

procedure TForm1.DoSelectingWnd;
var P: TPoint;
    R: TRect;
begin
  GetCursorPos( P );
  BestWnd := 0;
  CtrlPressed := GetKeyState( VK_CONTROL ) < 0;
  EnumWindows( @ EnumWndProc, Integer( @ P ) );
  if BestWnd <> 0 then
  begin
    GetWindowRect( BestWnd, R );
    Form.BoundsRect := R;
    Form.BringToFront;
    KOLForm1Resize( Form );
  end;
end;

procedure TForm1.StartCaptureRegion;
var P: TPoint;
begin
  GetCursorPos( P );
  Form.Left := P.x;
  Form.Top := P.y;
  Form.Width := 2;
  Form.Height := 2;
  Form.Show;
  SetForegroundWindow( Form.Handle );
  SetCapture( Form.Handle );
  Form.Cursor := LoadCursor( 0, IDC_CROSS );
  SetCursor( Form.Cursor );
  SelectingRgn := TRUE;
  Timer1.Enabled := TRUE;
end;

procedure TForm1.StartCaptureWnd;
var P: TPoint;
begin
  GetCursorPos( P );
  Form.Left := P.x;
  Form.Top := P.y;
  Form.Width := 2;
  Form.Height := 2;
  Form.Show;
  SetForegroundWindow( Form.Handle );
  SetCapture( Form.Handle );
  Form.Cursor := LoadCursor( 0, IDC_CROSS );
  SetCursor( Form.Cursor );
  SelectingWnd := TRUE;
  Timer1.Enabled := TRUE;
end;

procedure TForm1.StartCaptureScreen;
begin
  CaptureRegion( MakeRect( 0, 0, ScreenWidth, ScreenHeight ) );
end;

procedure TForm1.RepeatLastCapture;
begin
  if (LastRgn.Left >= LastRgn.Right) or (LastRgn.Top >= LastRgn.Bottom) then
    StartCaptureRegion
  else
    CaptureRegion( LastRgn );
end;

procedure TForm1.PopupMenu1miRepeatMenu(Sender: PMenu; Item: Integer);
begin
  PopupMenu1.ItemChecked[ miRepeat ] := not PopupMenu1.ItemChecked[ miRepeat ];
  if PopupMenu1.ItemChecked[ miRepeat ] then
    RepeatLastCapture;
end;

procedure TForm1.CaptureRegion(const R: TRect);
var
    DC: HDC;
    Ext: String;
var Path, S: String;
    I: Integer;
    Format: TPixelFormat;
    CI: TCursorInfo;
begin
  Form.Visible := FALSE;
  LastRgn := R;
  DC := GetDC( 0 );
  case GetDeviceCaps( DC, BITSPIXEL ) of
  1, 4, 8, 15, 16: Format := pf16bit;
  else {24, 32:} Format := pf24bit;
  end;
  Bmp.Free;
  Bmp := NewDIBBitmap( R.Right - R.Left, R.Bottom - R.Top, Format );
  BitBlt( Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, DC, R.Left, R.Top,
          SRCCOPY );
  ReleaseDC( 0, DC );
  PopupMenu1.ItemEnabled[ miSvAs ] := TRUE;
  if PopupMenu1.ItemChecked[ miCursor ] then
  begin // grab cursor also
    CI.cbSize := Sizeof( CI );
    GetCursorInfo( CI );
    if CI.flags <> 0 then
    begin
      DrawIconEx( Bmp.Canvas.Handle, CI.ptScreenPos.x - R.Left, CI.ptScreenPos.y - R.Top,
                  CI.hCursor, 0, 0, 0, 0, DI_DEFAULTSIZE or DI_NORMAL );
    end;
  end;

  Path := ExtractFilePath( LastFilename );
  S := ExtractFileNameWOext( LastFilename );
  Ext := ExtractFileExt( LastFilename );
  for I := Length( S ) downto 1 do
  begin
    if S[ I ] in [ '0'..'9' ] then Delete( S, I, 1 )
    else break;
  end;
  I := 0;
  if (S = '') or FileExists( Path + S + Ext ) then
  begin
    I := 1;
    while FileExists( Path + S + Int2Str( I ) + Ext ) do
      Inc( I );
  end;
  if FileExists( LastFilename ) then
  begin
    if I = 0 then
      Path := Path + S + Ext
    else
      Path := Path + S + Int2Str( I ) + Ext;
  end
    else
    Path := LastFilename;

  if PopupMenu1.ItemChecked[ miAuto ] and (Path <> '') then
  begin // save automatic on base of last filename
    SaveFile( Path );
  end
    else
  begin
    SaveAsDialog1.Filename := ExtractFileNameWOext( Path );
    if not PopupMenu1.ItemChecked[ miClipBrd ] and SaveAsDialog1.Execute then
    begin
      SaveFile( SaveAsDialog1.Filename );
    end
      else
    begin
      if not Bmp.CopyToClipboard then
      begin
        Attempts := 0;
        Timer3.Enabled := TRUE;
      end;
    end;
  end;
  //Bmp.Free;
  if PopupMenu1.ItemChecked[ miFrame ] then
  begin
    Form.Visible := TRUE;
    Form.Cursor := LoadCursor( hInstance, 'NOCURSOR' );
    KOLForm1Resize( Form );
  end;
  if RunOnce then
    PostQuitMessage( 0 );
end;

procedure TForm1.PopupMenu1miAutoMenu(Sender: PMenu; Item: Integer);
begin
  PopupMenu1.ItemChecked[ miAuto ] := not PopupMenu1.ItemChecked[ miAuto ];
end;

procedure TForm1.PopupMenu1miFolderMenu(Sender: PMenu; Item: Integer);
var DirPath: String;
begin
  if LastFilename <> '' then
    DirPath := ExtractFilePath( LastFilename )
  else
    DirPath := //GetSystemFolder( CSIDL_PERSONAL );
               SaveAsDialog1.InitialDir;
  if DirPath = '' then
    DirPath := GetSystemFolder( CSIDL_PERSONAL );
  ShellExecute( 0, 'explore', PChar( DirPath ), nil, nil, SW_SHOW );
end;

procedure TForm1.PopupMenu1miCursorMenu(Sender: PMenu; Item: Integer);
begin
  PopupMenu1.ItemChecked[ miCursor ] := not PopupMenu1.ItemChecked[ miCursor ];
end;

function TForm1.SetupHotkey(Func: Integer; Key: DWORD; M: DWORD; UseCurMod: Boolean=TRUE): Boolean;
begin
  if FHotKeyRegistered[ Func ] then
  begin
    UnregisterHotkey( Form.Handle, 1000 + Func );
    HotKey[ Func ] := 0;
    HotMod[ Func ] := 0;
  end;
  FHotkeyRegistered[ Func ] := RegisterHotkey( Form.Handle, 1000 + Func, M, Key );
  Result := FHotkeyRegistered[ Func ];
  if Result then
  begin
    HotKey[ Func ] := Key;
    HotMod[ Func ] := M;
  end;
end;

procedure TForm1.PopupMenu1miHotkeyMenu(Sender: PMenu; Item: Integer);
begin
  NewfmSelHotKey( fmSelHotKey, Applet );
  fmSelHotKey.Form.ShowModal;
  fmSelHotKey.Form.Free;
end;

function TForm1.KOLForm1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
var W: HWnd;
begin
  Result := FALSE;
  //if not FHotkeyRegistered[  ] then Exit;
  if (Msg.message = WM_HOTKEY) and
     ((fmSelHotKey = nil) or not fmSelHotKey.Form.Visible) then
  begin
    CASE Msg.wParam OF
    1000:   DoGrab;
    1000+1: PopupMenu1miRgnMenu( nil, 0 );
    1000+2: begin
              PostMessage( Form.Handle, WM_SelectForegroundWnd, 0, 0 );
            end;
    1000+3: PopupMenu1miScrMenu( nil, 0 );
    1000+4: RepeatLastCapture;
    else Exit;
    END;
    Result := TRUE;
  end
    else
  if Msg.message = WM_SelectForegroundWnd then
  begin
    W := GetForegroundWindow;
    PopupMenu1miWndMenu( nil, 0 );
    SelectWnd( W );
    Result := TRUE;
  end;
end;

procedure TForm1.DoGrab;
begin
  if PopupMenu1.ItemChecked[ miRepeat ] then
  begin
    RepeatLastCapture;
  end
    else
  if PopupMenu1.ItemChecked[ miRgn ] then
  begin // start capture region
    StartCaptureRegion;
  end
    else
  if PopupMenu1.ItemChecked[ miWnd ] then
  begin
    StartCaptureWnd;
  end
    else
  if PopupMenu1.ItemChecked[ miScr ] then
  begin
    StartCaptureScreen;
  end;
end;

procedure TForm1.KOLForm1Destroy(Sender: PObj);
var i: Integer;
begin
  for i := 0 to 4 do
  begin
    if FHotKeyRegistered[ i ] then
      UnregisterHotkey( Form.Handle, 1000 + i );
  end;
  Bmp.Free;
end;

procedure TForm1.PopupMenu1miFrameMenu(Sender: PMenu; Item: Integer);
begin
  PopupMenu1.ItemChecked[ miFrame ] := not PopupMenu1.ItemChecked[ miFrame ];
  if PopupMenu1.ItemChecked[ miFrame ] then
  begin
    Form.Cursor := LoadCursor( hInstance, 'NOCURSOR' );
    Form.Visible := TRUE;
    KOLForm1Resize( Form );
  end
    else
    Form.Visible := FALSE;
end;

procedure TForm1.PopupMenu1miSvAsMenu(Sender: PMenu; Item: Integer);
begin
  if not PopupMenu1.ItemChecked[ miClipBrd ] and SaveAsDialog1.Execute then
  begin
    SaveFile( SaveAsDialog1.Filename );
  end
    else
  begin
    if not Bmp.CopyToClipboard then
    begin
      Attempts := 0;
      Timer3.Enabled := TRUE;
    end;
  end;
end;

procedure TForm1.PopupMenu1miClipBrdMenu(Sender: PMenu; Item: Integer);
begin
  PopupMenu1.ItemChecked[ miClipBrd ] := not PopupMenu1.ItemChecked[ miClipBrd ];
end;

procedure TForm1.SaveFile(const Filename: String);
var Ext: String;
    Jpg: PJPeg;
    Png: PPngObject;
begin
      LastFilename := Filename;
      Ext := LowerCase( ExtractFileExt( Filename ) );
      if Ext = '.bmp' then
      begin
        Bmp.SaveToFile( Filename );
      end
        else
      if Ext = '.jpg' then
      begin
        Jpg := NewJpeg;
        Jpg.Bitmap := Bmp;
        Jpg.CompressionQuality := 75;
        Jpg.SaveToFile( Filename );
        Jpg.Free;
      end
        else
      if Ext = '.png' then
      begin
        Png := NewPngObject;
        Png.AssignHandle( Bmp.Handle, FALSE, 0 );
        Png.SaveToFile( Filename );
        Png.Free;
      end;
end;

procedure TForm1.KOLForm1Close(Sender: PObj; var Accept: Boolean);
begin
  SaveSettings;
end;

procedure TForm1.SaveSettings;
var R: THandle;
    I: Integer;
begin
  R := RegKeyOpenCreate( HKEY_CURRENT_USER, RegKey );
  TRY
    if PopupMenu1.ItemChecked[ miRgn ] then I := 0 else
    if PopupMenu1.ItemChecked[ miWnd ] then I := 1 else
       I := 2;
    RegKeySetDw( R, 'WhatGrab', I );
    RegKeySetDw( R, 'WithCorsor',
                 Integer( PopupMenu1.ItemChecked[ miCursor ] ) );
    RegKeySetDw( R, 'RepeatLastRegion',
                 Integer( PopupMenu1.ItemChecked[ miRepeat ] ) );
    RegKeySetDw( R, 'FrameAlways',
                 Integer( PopupMenu1.ItemChecked[ miFrame ] ) );
    RegKeySetDw( R, 'ClipboardOnly',
                 Integer( PopupMenu1.ItemChecked[ miClipBrd ] ) );
    RegKeySetDw( R, 'SaveAuto',
                 Integer( PopupMenu1.ItemChecked[ miAuto ] ) );

    RegKeySetDw( R, 'HotKey', HotKey[ 0 ] );
    RegKeySetDw( R, 'HotKeyModifier', HotMod[ 0 ] );

    for I := 1 to 4 do
      RegKeySetDw( R, 'HotKey' + Int2Str( I ), HotKey[ I ] );

    for I := 1 to 4 do
      RegKeySetDw( R, 'HotKeyModifier' + Int2Str( I ), HotMod[ I ] );

    RegKeySetStr( R, 'SaveAsFolder', ExtractFilePath( SaveAsDialog1.Filename ) );
    RegKeySetStr( R, 'LastFilename', LastFilename );
  FINALLY
    RegKeyClose( R );
  END;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
var R: THandle;
    I: Integer;
    Key, M: DWORD;
    S: String;
begin
  for I := 1 to ParamCount do
  begin
    S := ParamStr( I );
    if StrIsStartingFrom( PChar( UpperCase( S ) ), '/O' ) then
      RunOnce := TRUE
    else
    if StrIsStartingFrom( PChar( UpperCase( S ) ), '/W' ) then
      RunOnceWindow := TRUE
    else
    if StrIsStartingFrom( PChar( UpperCase( S ) ), '/S' ) then
      RunOnceScreen := TRUE;
  end;
  R := RegKeyOpenRead( HKEY_CURRENT_USER, RegKey );
  TRY
    if RegKeyValExists( R, 'WhatGrab' ) then
    begin
      I := RegKeyGetDw( R, 'WhatGrab' );
      CASE I OF
      0: PopupMenu1.RadioCheck( miRgn );
      1: PopupMenu1.RadioCheck( miWnd );
      else PopupMenu1.RadioCheck( miScr );
      END;
      PopupMenu1.ItemChecked[ miCursor  ] := 0 <> RegKeyGetDw( R, 'WithCorsor' );
      PopupMenu1.ItemChecked[ miRepeat  ] := 0 <> RegKeyGetDw( R, 'RepeatLastRegion' );
      PopupMenu1.ItemChecked[ miFrame   ] := 0 <> RegKeyGetDw( R, 'FrameAlways' );
      PopupMenu1.ItemChecked[ miClipBrd ] := 0 <> RegKeyGetDw( R, 'ClipboardOnly' );
      PopupMenu1.ItemChecked[ miAuto    ] := 0 <> RegKeyGetDw( R, 'SaveAuto' );
      Key := RegKeyGetDw( R, 'HotKey' );
      M   := RegKeyGetDw( R, 'HotKeyModifier' );
      if Key <> 0 then SetupHotkey( 0, Key, M, FALSE );
      for I := 1 to 4 do
      begin
        Key := RegKeyGetDw( R, 'HotKey' + Int2Str( I ) );
        M   := RegKeyGetDw( R, 'HotKeyModifier' + Int2Str( I ) );
        if Key <> 0 then SetupHotkey( I, Key, M, FALSE );
      end;
      S := RegKeyGetStr( R, 'SaveAsFolder' );
      if DirectoryExists( S ) then
        SaveAsDialog1.InitialDir := S;
      LastFilename := RegKeyGetStr( R, 'LastFilename' );
    end;
  FINALLY
    RegKeyClose( R );
  END;
  if RunOnce then
  begin
    if RunOnceWindow then
      StartCaptureWnd
    else
    if RunOnceScreen then
    begin
      StartCaptureScreen;
      //Form.Close;
      PostQuitMessage( 0 );
    end
      else
      StartCaptureRegion;
  end;
end;

procedure TForm1.Timer2Timer(Sender: PObj);
begin
  Timer2.Enabled := FALSE;
  CaptureRegion( Form.BoundsRect );
end;

procedure TForm1.TrayIcon1Mouse(Sender: PObj; Message: Word);
var P: TPoint;
begin
  if Message = WM_LBUTTONDOWN then
  begin
    DoGrab;
  end
    else
  if Message = WM_RBUTTONDOWN then
  begin
    GetCursorPos( P );
    PopupMenu1.PopupEx( P.x, P.y );
    SelectingRgn := FALSE;
    SelectingRgn2 := FALSE;
    SelectingWnd := FALSE;
    Timer1.Enabled := FALSE;
  end;
end;

procedure TForm1.Timer3Timer(Sender: PObj);
begin
  Timer3.Enabled := FALSE;
  if Bmp <> nil then
  begin
    if not Bmp.CopyToClipboard then
    begin
      Inc( Attempts );
      if Attempts < 5 then
        Timer3.Enabled := TRUE;
    end;
  end;
  if not Timer3.Enabled then
    Attempts := 0;
end;

function TForm1.KOLApplet1Message(var Msg: tagMSG;
  var Rslt: Integer): Boolean;
begin
  Result := FALSE;
  if SelectingWnd then
  begin
    if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_LEFT) then
      SelectNextWnd( VK_LEFT )
    else
    if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_RIGHT) then
      SelectNextWnd( VK_RIGHT )
    else
    if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_UP) then
      SelectNextWnd( VK_UP )
    else
    if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_DOWN) then
      SelectNextWnd( VK_DOWN )
  end;
  if SelectingRgn or SelectingWnd then
  begin
    if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_RETURN) then
    begin
      ReleaseCapture;
      Form.Hide;
      Timer1.Enabled := FALSE;
      SelectingRgn2 := FALSE;
      SelectingWnd := FALSE;
      Timer2.Enabled := TRUE;
    end
    else
    if (Msg.message = WM_KEYDOWN) and (Msg.wParam = VK_ESCAPE) then
    begin
      Form.Hide;
      Timer1.Enabled := FALSE;
      SelectingRgn := FALSE;
      SelectingRgn2 := FALSE;
      SelectingWnd := FALSE;
      ReleaseCapture;
      if RunOnce then
        PostQuitMessage( 0 );
    end;
  end;
end;

var KeyPressed: DWORD;
    OldBestWnd: HWnd;
    OldBstWndRect: TRect;
    WndList: PList;
var ScrRect: TRect;

function EnumWndNext( Wnd: HWnd; P: PPoint ): BOOL; stdcall;
    procedure CheckWndAndItsChildren( Wnd: HWnd );
    var R: TRect;
    begin
      if IsWindowVisible( Wnd ) then
      begin
        GetWindowRect( Wnd, R );
        if R.Top < ScrRect.Bottom then
        if R.Bottom > 0 then
        if R.Left < ScrRect.Right then
        if R.Right > 0 then
        if R.Right > R.Left then
        if R.Bottom > R.Top then
        begin
          WndList.Add( Pointer( Wnd ) );
          Wnd := GetWindow( Wnd, GW_CHILD );
          while Wnd <> 0 do
          begin
            CheckWndAndItsChildren( Wnd );
            Wnd := GetWindow( Wnd, GW_HWNDNEXT );
          end;
        end;
      end;
    end;
begin
  if Wnd <> Form1.Form.Handle then
  if Wnd <> Applet.Handle then
  if IsWindowVisible( Wnd ) then
    CheckWndAndItsChildren( Wnd );
  Result := TRUE;
end;

function CompareWnd(const Data: Pointer; const e1,e2 : Dword) : Integer;
var W1, W2: HWnd;
    R1, R2: TRect;
begin
  W1 := HWnd( WndList.Items[ e1 ] );
  W2 := HWnd( WndList.Items[ e2 ] );
  GetWindowRect( W1, R1 );
  GetWindowRect( W2, R2 );
  Result := 0;
  CASE KeyPressed OF
  VK_LEFT, VK_RIGHT:
    if R1.Top < R2.Top then Result := -1
    else
    if R1.Top = R2.Top then
      Result := R1.Left - R2.Left
    else
    Result := 1;
  VK_UP, VK_DOWN:
    if R1.Left < R2.Left then Result := -1
    else
    if R1.Left = R2.Left then
      Result := R1.Top - R2.Top
    else
    Result := 1;
  END;
  if Result = 0 then
    Result := W1 - W2;
end;

procedure Swap(const Data : Pointer; const e1,e2 : Dword);
begin
  WndList.Swap( e1, e2 );
end;

procedure TForm1.SelectNextWnd( Key: DWORD );
var i: Integer;
    R: TRect;
begin
  ScrRect := MakeRect( 0, 0, ScreenWidth, ScreenHeight );
  KeyPressed := Key;
  OldBestWnd := BestWnd;
  if OldBestWnd <> 0 then
    GetWindowRect( OldBestWnd, OldBstWndRect );
  BestWnd := 0;
  WndList := NewList;
  TRY
    EnumWindows( @ EnumWndNext, 0 );
    SortData( WndList, WndList.Count, CompareWnd, Swap );
    i := WndList.IndexOf( Pointer( OldBestWnd ) );
    if i < 0 then i := 0
    else
    CASE Key OF
    VK_RIGHT, VK_DOWN:
      Inc( i );
    VK_LEFT, VK_UP:
      Dec( i );
    END;
    if i < 0 then i := WndList.Count-1
    else if i>= WndList.Count-1 then i := 0;
    if (i >= 0) and (i < WndList.Count) then
      BestWnd := HWnd( WndList.Items[ i ] );
    if BestWnd <> 0 then
    begin
      GetWindowRect( BestWnd, R );
      Form.BoundsRect := R;
      Form.BringToFront;
      KOLForm1Resize( Form );
    end;
  FINALLY
    WndList.Free;
  END;
end;

procedure TForm1.SelectWnd( W: HWnd );
var R: TRect;
begin
  if W <> 0 then
  begin
    GetCursorPos( LastMouseMoveP );
    BestWnd := W;
    GetWindowRect( BestWnd, R );
    Form.BoundsRect := R;
    Form.BringToFront;
    KOLForm1Resize( Form );
  end;
end;

end.



