{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit UnitSelectHotKey;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL {$IFNDEF KOL_MCK}, mirror, Classes,
  Controls, mckCtrls, mckObjs, StdCtrls {$ENDIF};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} TfmSelHotKey = class; PfmSelHotKey = TfmSelHotKey; {$ELSE OBJECTS} PfmSelHotKey = ^TfmSelHotKey; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TfmSelHotKey.inc}{$ELSE} TfmSelHotKey = object(TObj) {$ENDIF}
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TfmSelHotKey = class(TForm)
  {$ENDIF KOL_MCK}
    GradientPanel1: TKOLGradientPanel;
    ImageShow1: TKOLImageShow;
    ImageList1: TKOLImageList;
    LabelEffect1: TKOLLabelEffect;
    Label1: TKOLLabel;
    Label2: TKOLLabel;
    KOLForm1: TKOLForm;
    ImageList2: TKOLImageList;
    Label3: TKOLLabel;
    eSame: TKOLEditBox;
    BitBtn1: TKOLBitBtn;
    eRegion: TKOLEditBox;
    eWindow: TKOLEditBox;
    eScreen: TKOLEditBox;
    RadioBox1: TKOLRadioBox;
    RadioBox2: TKOLRadioBox;
    RadioBox3: TKOLRadioBox;
    RadioBox4: TKOLRadioBox;
    BitBtn2: TKOLBitBtn;
    BitBtn3: TKOLBitBtn;
    BitBtn4: TKOLBitBtn;
    BitBtn5: TKOLBitBtn;
    RadioBox5: TKOLRadioBox;
    eLast: TKOLEditBox;
    BitBtn6: TKOLBitBtn;
    procedure KOLForm1Show(Sender: PObj);
    procedure KOLForm1KeyDown(Sender: PControl; var Key: Integer;
      Shift: Cardinal);
    procedure Label2MouseEnter(Sender: PObj);
    procedure Label2MouseLeave(Sender: PObj);
    procedure Label2Click(Sender: PObj);
    procedure BitBtn1Click(Sender: PObj);
    procedure KOLForm1MouseDown(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure RadioBox1Click(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure BitBtn2Click(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
    CurHotKey: Integer;
    procedure ShowHotKeys;
  end;

var
  fmSelHotKey {$IFDEF KOL_MCK} : PfmSelHotKey {$ELSE} : TfmSelHotKey {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewfmSelHotKey( var Result: PfmSelHotKey; AParent: PControl );
{$ENDIF}

implementation

uses MainUnit;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I UnitSelectHotKey_1.inc}
{$ENDIF}

procedure TfmSelHotKey.KOLForm1Show(Sender: PObj);
begin
  LabelEffect1.Caption := LabelEffect1.Caption + AppVersion;
  ShowHotKeys;
end;

procedure TfmSelHotKey.KOLForm1KeyDown(Sender: PControl; var Key: Integer;
  Shift: Cardinal);
var M: DWORD;
begin
  if Key = VK_ESCAPE then
  begin
    Form.ModalResult := -1;
    Exit;
  end;
  if (Key <> VK_SHIFT) and (Key <> VK_CONTROL) and
     (Key <> VK_MENU) and (Key <> VK_LWIN) and (Key <> VK_RWIN) then
  begin
    M := 0;
    if GetKeyState( VK_SHIFT ) < 0 then
      M := M or MOD_SHIFT;
    if GetKeyState( VK_CONTROL ) < 0 then
      M := M or MOD_CONTROL;
    if GetKeyState( VK_MENU ) < 0 then
      M := M or MOD_ALT;
    if (GetKeyState( VK_LWIN ) < 0) or (GetKeyState( VK_RWIN ) < 0) then
      M := M or MOD_WIN;
    if M <> 0 then
    begin
      if not Form1.SetupHotkey( CurHotKey, Key, M, TRUE ) then
        ShowMessage( 'Hot key could not be registered: ' +
        SysErrorMessage( GetLastError ) )
      else
      begin
        ShowHotKeys;
        Form1.SaveSettings;
      end;
    end;
  end;
end;

procedure TfmSelHotKey.Label2MouseEnter(Sender: PObj);
begin
  Label2.Font.FontStyle := [ fsBold, fsItalic ];
end;

procedure TfmSelHotKey.Label2MouseLeave(Sender: PObj);
begin
  Label2.Font.FontStyle := [ fsBold ];
end;

procedure TfmSelHotKey.Label2Click(Sender: PObj);
begin
  ShellExecute( 0, nil, PChar( Label2.Caption ), nil, nil, SW_SHOW );
end;

procedure TfmSelHotKey.BitBtn1Click(Sender: PObj);
begin
  Form.Close;
end;

procedure TfmSelHotKey.KOLForm1MouseDown(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  if Mouse.Button = mbLeft then
    Form.DragStart;
end;

procedure TfmSelHotKey.ShowHotKeys;
  procedure ShowForItem( I: Integer; E: PControl );
  var A: TMenuAccelerator;
      M: DWORD;
  begin
    FillChar( A, Sizeof( A ), 0 );
    A.Key := Form1.HotKey[ I ];
    M := Form1.HotMod[ I ];
    if M and MOD_SHIFT   <> 0 then A.fVirt := FSHIFT;
    if M and MOD_CONTROL <> 0 then A.fVirt := A.fVirt or FCONTROL;
    if M and MOD_ALT     <> 0 then A.fVirt := A.fVirt or FALT;
    if M and MOD_WIN     <> 0 then A.fVirt := A.fVirt or $20;
    E.Text := GetAcceleratorText( A );
  end;
begin
  ShowForItem( 0, eSame );
  ShowForItem( 1, eRegion );
  ShowForItem( 2, eWindow );
  ShowForItem( 3, eScreen );
  ShowForItem( 4, eLast );
end;

procedure TfmSelHotKey.RadioBox1Click(Sender: PObj);
begin
  CurHotKey := Sender.Tag;
end;

procedure TfmSelHotKey.KOLForm1FormCreate(Sender: PObj);
begin
  eSame  .LikeSpeedButton;
  eRegion.LikeSpeedButton;
  eWindow.LikeSpeedButton;
  eScreen.LikeSpeedButton;
end;

procedure TfmSelHotKey.BitBtn2Click(Sender: PObj);
begin
  if Form1.HotKey[ Sender.Tag ] <> 0 then
  begin
    UnregisterHotkey( Form1.Form.Handle, 1000 + Sender.Tag );
    Form1.HotKey[ Sender.Tag ] := 0;
    Form1.HotMod[ Sender.Tag ] := 0;
    ShowHotKeys;
  end;
end;

end.





